package com.example.monnthic.monnthicmobile;

import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

public class SignupActivity extends AppCompatActivity {

    private EditText name;
    private EditText firstname;
    private EditText email;
    private EditText confirmEmail;
    private EditText password;
    private EditText confirmPassword;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_signup);

        name = findViewById(R.id.inputName);
        firstname = findViewById(R.id.inputPrenom);
        email = findViewById(R.id.inputEmail);
        confirmEmail = findViewById(R.id.inputConfEmail);
        password = findViewById(R.id.inputPassword);
        confirmPassword = findViewById(R.id.inputConfPassword);
        Button buttonCancel = findViewById(R.id.buttonCancel);
        Button buttonOk = findViewById(R.id.buttonOk);

        buttonCancel.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                finish();
            }
        });

        buttonOk.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                validateInput();
            }
        });
    }

    //TODO VERIFY EACH EDIT TEXT
    public void validateInput(){
        if(isEmptyEdit(name)){
            Toast.makeText(this, "You did not enter your name", Toast.LENGTH_SHORT).show();
        } else if(isEmptyEdit(firstname)){
            Toast.makeText(this, "You did not enter your firstname", Toast.LENGTH_SHORT).show();
        } else if(isEmptyEdit(email)){
            Toast.makeText(this, "You did not enter your email", Toast.LENGTH_SHORT).show();
        } else if(isEmptyEdit(confirmEmail)){
            Toast.makeText(this, "You did not confirm your email", Toast.LENGTH_SHORT).show();
        } else if(isEmptyEdit(password)){
            Toast.makeText(this, "You did not enter your password", Toast.LENGTH_SHORT).show();
        } else if(isEmptyEdit(confirmPassword)){
            Toast.makeText(this, "You did not confirm your password", Toast.LENGTH_SHORT).show();
        }else {
            if(!(password.getText().toString().equals(confirmPassword.getText().toString()))){
                Toast.makeText(this, "Password don't match confirmation password", Toast.LENGTH_SHORT).show();
            }else if(!(email.getText().toString().equals(confirmEmail.getText().toString()))){
                Toast.makeText(this, "Email don't match confirmation email", Toast.LENGTH_SHORT).show();
            } else{
                User inputUser = new User(name.getText().toString(),firstname.getText().toString(),email.getText().toString(),password.getText().toString());
                insertUserLdap(inputUser);
            }
        }
    }

    //TODO INSERT VALIDE USER INTO LDAP
    public void insertUserLdap(User u){
        //CHECK IF USER ALREADY EXIST

        //IF USER DOESN'T EXIST, INSERT USER INTO LDAP

        //CHECK RESPONSE OR RESULT OF INSERT

        //IF SUCCESSFULLY INSERTED INTO LDAP CALL LAUNCHWALLET

        //TEMPORARY
        if(checkUser(u.getEmail())){
            Toast.makeText(this, "User already have an account, please log in", Toast.LENGTH_SHORT).show();
        }else {
            Toast.makeText(this, "INSERT", Toast.LENGTH_SHORT).show();
            launchWalletActivity(1);
        }
    }

    //TODO LAUNCH WALLET ACTIVITY
    public void launchWalletActivity(int ldapId){;
        //LAUNCH APP WALLET WITH ID USER
        Intent walletIntent = new Intent(SignupActivity.this, WalletActivity.class);
        walletIntent.putExtra("idUser", ldapId);
        SignupActivity.this.startActivity(walletIntent);
        finish();
    }

    private boolean isEmptyEdit(EditText etText) {
        return etText.getText().toString().trim().length() == 0;
    }
    //TODO VERIFY IF INPUTED USER ALREADY EXIST IN LDAP
    private boolean checkUser(Object mail){
        //Statement stmt = null;
        //String query = "SELECT userId FROM USER_TABLE WHERE email="+mail;
        return false;
    }
}
