package com.example.monnthic.monnthicmobile;

import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import java.math.BigInteger;

public class WalletPresenterActivity extends AppCompatActivity {
    private EditText addressPublic;
    private TextView balance;
    private String address;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_wallet_presenter);
        addressPublic = findViewById(R.id.address_pub);
        balance = findViewById(R.id.balance);
        Button refreshBalance = findViewById(R.id.refreshBalance);
        Button buttonSendTransaction = findViewById(R.id.send_transaction);
        Intent intent = getIntent();
        address = intent.getStringExtra("WALLET_ADDRESS");

        addressPublic.setText(address);

        if(initiateBalance(address)==null){
            balance.setText("Error");
        }else{
            balance.setText(initiateBalance(address).toString());
        }

        buttonSendTransaction.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                launchTransactionActivity();
            }
        });

        refreshBalance.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                initiateBalance(address);
            }
        });
    }

    public void launchTransactionActivity(){
        Intent transactionIntent = new Intent(WalletPresenterActivity.this, TransactionActivity.class);
        WalletPresenterActivity.this.startActivity(transactionIntent);
    }

    public BigInteger initiateBalance(String address){
        AccessBlockchain ab = new AccessBlockchain();
        System.out.println("addresse "+ address);
        BigInteger balanceIs = ab.getTheBalanceOfWallet(address);
        return balanceIs;
    }
}
